#ifndef MODELCONVERTER_READERS_MCINI_H
#define MODELCONVERTER_READERS_MCINI_H

#include <Rtypes.h>
#include <TChain.h>
#include <TLorentzVector.h>

#include <mciEvent.h>
#include <mciParticle.h>
#include <Utility.h>

#include <mciReader_manager.h>

#include <URun.h>
#include <UEvent.h>
#include <UParticle.h>
#include <EventInitialState.h>

class mciReader_mcini : virtual public mciReader_manager
{
private:
  TChain *fChain;

  const char *fChainName = "events";

  bool is_init;
  Long64_t fCurrentEvent;

  UEvent *fEvent;
  UParticle *fParticle;
  TLorentzVector fMomentum;

  Bool_t ChainCheck();

public:
  mciReader_mcini(/* args */);
  virtual ~mciReader_mcini();

  virtual void SetChain(const TString &inputFileName);
  virtual Long64_t GetEntries() { return fChain->GetEntries(); }
  virtual mciEvent *ReadEvent(Long64_t iev);
  virtual mciParticle* ReadParticle(Int_t ipart);

  ClassDef(mciReader_mcini, 0);
};

#endif
