#ifndef MODELCONVERTER_READERS_PHQMD_H
#define MODELCONVERTER_READERS_PHQMD_H

#include <Rtypes.h>
#include <TChain.h>
#include <TLorentzVector.h>

#include <mciEvent.h>
#include <mciParticle.h>
#include <Utility.h>

#include <mciReader_manager.h>

#include <phqmd2root/src/libPHQMDEvent.h>

class mciReader_phqmd : virtual public mciReader_manager
{
private:
  TChain *fChainPHSD, *fChainFrag;

  const char *fChainPHSDName = "PHQMDtree";
  const char *fChainFragName = "FRAGtree";

  bool is_init;
  Long64_t fCurrentEvent;

  Event *fEvent;
  EventClust *fEventFrag;
  Particle *fParticle;
  Baryon *fBaryonMST;
  Fragment *fFragmentMST;
  TLorentzVector fMomentum;
  Int_t fNpart;

  Bool_t ChainCheck();

public:
  mciReader_phqmd(/* args */);
  virtual ~mciReader_phqmd();

  virtual void SetChain(const TString &inputFileName);
  virtual Long64_t GetEntries() { return fChainFrag->GetEntries(); }
  virtual mciEvent *ReadEvent(Long64_t iev);
  virtual mciParticle* ReadParticle(Int_t ipart);

  ClassDef(mciReader_phqmd, 0);
};

#endif