#include <mciReader_smash_root.h>

ClassImp(mciReader_smash_root);

mciReader_smash_root::mciReader_smash_root(/* args */) : is_init(false), fCurrentEvent(-1)
{
}

mciReader_smash_root::~mciReader_smash_root()
{
}

Bool_t mciReader_smash_root::ChainCheck()
{
  if (!is_init)
  {
    return false;
  }

  if (fCurrentEvent == -1)
  {
    return false;
  }

  if (!fChain->GetEntry(fCurrentEvent))
  {
    return false;
  }

  return true;
}

void mciReader_smash_root::SetChain(const TString &inputFileName)
{
  fChain = (TChain *)mciUtility::GetInstance()->initChain(inputFileName, fChainName);

  fChain->SetBranchAddress("npart", &npart);
  fChain->SetBranchAddress("impact_b", &impact_b);
  fChain->SetBranchAddress("pdgcode", pdgcode);
  fChain->SetBranchAddress("p0", p0);
  fChain->SetBranchAddress("px", px);
  fChain->SetBranchAddress("py", py);
  fChain->SetBranchAddress("pz", pz);
  fChain->SetBranchAddress("t", t);
  fChain->SetBranchAddress("x", x);
  fChain->SetBranchAddress("y", y);
  fChain->SetBranchAddress("z", z);

  is_init = kTRUE;
}

mciEvent *mciReader_smash_root::ReadEvent(Long64_t iev)
{
  mciEvent *event = new mciEvent();
  fCurrentEvent = iev;

  if (!ChainCheck())
  {
    return event;
  }

  event->SetB(impact_b);
  event->SetPhiRP(0.);
  event->SetNparticles(npart);

  return event;
}

mciParticle *mciReader_smash_root::ReadParticle(Int_t ipart)
{
  mciParticle *particle = new mciParticle();
  if (!ChainCheck())
  {
    return particle;
  }

  if (ipart >= npart)
  {
    return particle;
  }

  particle->SetEnergy(p0[ipart]);
  particle->SetPdg(pdgcode[ipart]);
  particle->SetPxPyPz(px[ipart], py[ipart], pz[ipart]);
  particle->SetTime(t[ipart]);
  particle->SetXYZ(x[ipart], y[ipart], z[ipart]);
  particle->SetCharge(mciUtility::GetInstance()->GetCharge(pdgcode[ipart]));

  return particle;
}
