#ifndef MODELCONVERTER_WRITER_MANAGER_H
#define MODELCONVERTER_WRITER_MANAGER_H

#include <Rtypes.h>
#include <TString.h>

#include <mciEvent.h>
#include <mciParticle.h>
#include <Utility.h>

class mciWriter_manager
{
private:
  /* data */
public:
  virtual ~mciWriter_manager();

  virtual void SetFile(const TString &outputFileName) = 0;
  virtual void SetEvent(mciEvent *const& _ievent) = 0;
  virtual void SetParticle(mciParticle *const& _iparticle, Int_t id) = 0;
  virtual void Fill() = 0;
  virtual void Write() = 0;
  virtual void Close() = 0;

  ClassDef(mciWriter_manager,0);
};

#endif
