#ifndef MODELCONVERTER_WRITERS_MCPICO_H
#define MODELCONVERTER_WRITERS_MCPICO_H

#include <Rtypes.h>
#include <TFile.h>
#include <TTree.h>

#include <mciEvent.h>
#include <mciParticle.h>
#include <Utility.h>

#include <mciWriter_manager.h>

class mciWriter_mcpico : virtual public mciWriter_manager
{
private:
  
  TFile *fOutFile;
  TTree *fTree;

  const char *fTreeName = "mctree";

  Float_t         bimp;
  Float_t         phi2;
  Float_t         phi3;
  Float_t         ecc2;
  Float_t         ecc3;
  Int_t           npart;
  Int_t           nh;
  Float_t         momx[MAX_TRACKS];   //[nh]
  Float_t         momy[MAX_TRACKS];   //[nh]
  Float_t         momz[MAX_TRACKS];   //[nh]
  Float_t         ene[MAX_TRACKS];   //[nh]
  Int_t           hid[MAX_TRACKS];   //[nh]
  Int_t           pdg[MAX_TRACKS];   //[nh]
  Short_t         charge[MAX_TRACKS];   //[nh]

public:
  mciWriter_mcpico(/* args */);
  virtual ~mciWriter_mcpico();

  virtual void SetFile(const TString &outputFileName);
  virtual void SetEvent(mciEvent *const& _ievent);
  virtual void SetParticle(mciParticle *const& _iparticle, Int_t id);
  virtual void Fill();
  virtual void Write();
  virtual void Close();

  ClassDef(mciWriter_mcpico, 0);
};


#endif